﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Diagnostics;


public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void bntVisualizza_Click(object sender, EventArgs e)
    {
        if (caricaFile3gp.HasFile)
        {
            string ext = Path.GetExtension(caricaFile3gp.FileName).ToLower();

            if (ext.Equals(".3gp"))
            {

                #region Salvataggio del File 3GP nella cartella del portale
              
                string fileName3GP = "3GP\\" + caricaFile3gp.FileName;
                string filePath3GP = Request.PhysicalApplicationPath;
                filePath3GP += fileName3GP;
                caricaFile3gp.SaveAs(filePath3GP); 
              
                #endregion


                #region Creao il nome del File Flash da utilizzare nella procedura di conversione
               
                string fileNameFLV = "FLV\\" + caricaFile3gp.FileName.Split('.')[0] + "_" + DateToString(DateTime.Now) + ".flv";
                string filePathFLV = Request.PhysicalApplicationPath;
                filePathFLV += fileNameFLV; 
              
                #endregion

                #region Conversione 3GP --> FLV (il processo si ferma finchè non viene ultimata la conversione)
              
                string strPathExe = Request.PhysicalApplicationPath;

                Process myProc = new Process();
                myProc = new Process();
                myProc.StartInfo.FileName = strPathExe + "ffmpeg\\ffmpeg";
                myProc.StartInfo.Arguments = " -i " + filePath3GP + " -sameq -an " + filePathFLV + " ";
                myProc.StartInfo.UseShellExecute = false;
                myProc.StartInfo.CreateNoWindow = true;
                myProc.StartInfo.RedirectStandardOutput = false;
                myProc.Start();
                myProc.WaitForExit(); 

                #endregion


                #region Il video convertito viene mandato al player flash (presente nella cartella Player)
                
                string video = "//3gp_flv//" + fileNameFLV;

                if (rdoGrande.Checked)
                {
                    divFlash.InnerHtml = "<object classid=clsid:D27CDB6E-AE6D-11cf-96B8-444553540000 codebase=http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0 width=800 height=600>";
                    divFlash.InnerHtml += " <param name=movie value=Player/BigPlayerVideo.swf?vid=" + video + ">";
                    divFlash.InnerHtml += " <param name=quality value=high>";
                    divFlash.InnerHtml += " <embed src=Player/BigPlayerVideo.swf?vid=" + video + " quality=high pluginspage=http://www.macromedia.com/go/getflashplayer type=application/x-shockwave-flash width=800 height=600></embed>";
                    divFlash.InnerHtml += "</object>";
                }
                else
                {
                    divFlash.InnerHtml = "<object classid=clsid:D27CDB6E-AE6D-11cf-96B8-444553540000 codebase=http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0 width=300 height=250>";
                    divFlash.InnerHtml += " <param name=movie value=Player/PreviewPlayerVideo.swf?vid=" + video + ">";
                    divFlash.InnerHtml += " <param name=quality value=high>";
                    divFlash.InnerHtml += " <embed src=Player/PreviewPlayerVideo.swf?vid=" + video + " quality=high pluginspage=http://www.macromedia.com/go/getflashplayer type=application/x-shockwave-flash width=300 height=250></embed>";
                    divFlash.InnerHtml += "</object>";
                } 

                #endregion

            }
        }
     
    }
    protected string DateToString(DateTime data)
    {
        return (Convert.ToString(data.Year) + (data.Month < 10 ? "0" : "") + Convert.ToString(data.Month) + (data.Day < 10 ? "0" : "") + Convert.ToString(data.Day) + (data.Hour < 10 ? "0" : "") + Convert.ToString(data.Hour) + (data.Minute < 10 ? "0" : "") + Convert.ToString(data.Minute) + (data.Second < 10 ? "0" : "") + Convert.ToString(data.Second));
    }
}

